function setup() {
    if (window.widget) {
    	// productType    	
    	var productType = widget.preferenceForKey("productType");    	
    	if (productType) { // check if preference is set
			document.getElementById("productType").selectedIndex = productType;
		} else {
			widget.setPreferenceForKey(0,"productType");
		}

    	// storeLocale    	
    	var storeLocale = widget.preferenceForKey("storeLocale");    	
    	if (storeLocale) { // check if preference is set
			document.getElementById("storeLocale").selectedIndex = storeLocale;
		} else {
			widget.setPreferenceForKey(0,"storeLocale");
		}		
	}

	// headline
	var type;
	if(document.getElementById("productType").selectedIndex == 0) type = "book";
	if(document.getElementById("productType").selectedIndex == 1) type = "music";
	if(document.getElementById("productType").selectedIndex == 2) type = "DVD";
	if(document.getElementById("productType").selectedIndex == 3) type = "hardware";
	if(document.getElementById("productType").selectedIndex == 4) type = "software";

	document.getElementById("headline-product-type").innerText = type;
}


function changeProductType(selected) {	
	if (window.widget) {
		widget.setPreferenceForKey(selected.selectedIndex,"ProductType");
	}

	// headline
	var type;
	if(selected.selectedIndex == 0) type = "book";
	if(selected.selectedIndex == 1) type = "music";
	if(selected.selectedIndex == 2) type = "DVD";
	if(selected.selectedIndex == 3) type = "hardware";
	if(selected.selectedIndex == 4) type = "software";

	document.getElementById("headline-product-type").innerText = type;
}


function submitField(keyword) {
	
	if (window.widget) {
		if ( keyword.value.length > 0) {
			submittedKeywords = keyword.value;
			
			var productType = document.getElementById("productType").value;
			var storeLocale = document.getElementById("storeLocale").value;
			
			searchKeywords = submittedKeywords.replace(/[\s]/gi, '+');
			
			URL = "http://www.amascore.com/query.jsp?keywords=" + searchKeywords + "&productType=" + productType + "&storeLocale=" + storeLocale;
			
			widget.openURL(URL);
		}
	}
}

////////////////////////////////////////////////////////////////////////////////

// circle over i on event
function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

// circle over i on event
function enterreturn(event) {
	document.getElementById('returnrollie').style.display = 'block';
}

function exitreturn(event) {
	document.getElementById('returnrollie').style.display = 'none';
}


function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}


function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
    
    exitflip(event);
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

////////////////////////////////////////////////////////////////////////////////

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit(event) {
    if (flipShown) {
        // fade in the info button
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function mousemove_back(event) {
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('return');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit_back(event) {
    if (flipShown) {
        // fade in the info button
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('return');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();
                
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration) {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}


////////////////////////////////////////////////////////////////////////////////


// Mouseover events for logo
function enterLogo(event) {
    document.getElementById("wc_logo_over").style.visibility = "visible";
}

function exitLogo(event) {
    document.getElementById("wc_logo_over").style.visibility = "hidden";
}

function wrapURL(url) {
    if (window.widget)
        widget.openURL(url);
    else
        window.location = url;
}
